local untables = 0
local tableclear = false
local spawnx = 0
local spawny = 0
local spawnz = 0
local animtimer = 0

local function ValidToken()
	for mobj in mobjs.iterate() do
		if not (mobj and mobj.valid) then continue end
		if not mobj.type == MT_TOKEN then continue end
		if not mobj.icecream then continue end
		return true
	end
	return false
end

addHook("MapChange", function(mapnum)
	untables = 0
	tableclear = false
	animtimer = 0
end)

addHook("LinedefExecute", function(line, mobj)
	if gamemap ~= 642 then return end
	if mobj == nil then return end
	if tableclear == true then return end
	untables = $ + 1 --count broken tables
	if untables == 3 and ValidToken() then --summon emblem/token
		P_PlayJingleMusic(mobj.player, "ICECRM", 0, false, JT_OTHER)
		tableclear = true
		spawnx = mobj.x
		spawny = mobj.y
		spawnz = mobj.z + 46*FU
		mobj.tablebroker = true
		mobj.storedx = mobj.momx
		mobj.storedy = mobj.momy
		mobj.storedz = mobj.momz
		mobj.storedstate = mobj.state
	end
end, "TABLE")

--emblem thinker
--since lua cant read custom fields made in uzb i use this
addHook("MobjSpawn", function(token)
	if token.floorz == 69*FU then token.icecream = true end
end, MT_TOKEN)

addHook("MobjThinker", function(token)
	if gamemap ~= 642 then return end
	if token.icecream == nil then return end
	if tableclear == true and animtimer < 175 then --the part where all tables broken and the animation didnt played
		if animtimer == 0
			P_SetOrigin(token, spawnx, spawny, spawnz)
		end
		animtimer = $+1
		for p in players.iterate do
			if p.mo.tablebroker == true
				p.mo.momx = 0
				p.mo.momy = 0
				p.mo.momz = 0
				p.mo.state = p.mo.storedstate
				p.pflags = $ | PF_JUMPSTASIS
			end
		end
		P_TeleportCameraMove(camera, spawnx - 320*FU, spawny - 320*FU, spawnz + 80*FU)
		camera.angle = R_PointToAngle(spawnx, spawny)
		if animtimer > 150
			token.z = spawnz
		elseif animtimer > 100
			token.z = $ - 10*FU*(animtimer-100)
		elseif animtimer > 50
			token.z = $ + 10*FU*(animtimer-50)
		end
	end
	if animtimer == 175 then --animation finish
		animtimer = $+1
		for p in players.iterate do
			if p.mo.tablebroker == true
				p.mo.momx = p.mo.storedx
				p.mo.momy = p.mo.storedy
				p.mo.momz = p.mo.storedz
				p.pflags = $ & ~PF_JUMPSTASIS
				P_RestoreMusic(p)
			end
		end
		token.icecream = false
	end
end, MT_TOKEN)

addHook("TouchSpecial", function(token, mo)
	if token.icecream then return true end
end, MT_TOKEN)

addHook("ShouldJingleContinue", function(p, musname)
	if animtimer > 175 then return false
	else return true
	end
end, "ICECRM")