--egg launcher states
states[S_EGGL_BASIC] = {SPR_EGGL, A, 1, A_Chase, 3, 0, S_EGGL_BASIC}
states[S_EGGL_PAIN] = {SPR_EGGL, A, 26, A_Pain, 0, 0, S_EGGL_BASIC}
states[S_EGGL_DEATH] = {SPR_EGGL, A, 5, A_BossScream, 0, MT_SONIC3KBOSSEXPLODE, S_EGGL_DEATH}
states[S_EGGL_DEATH2] = {SPR_EGGL, A, 20, nil, 0, 0, S_EGGL_FLEE}
states[S_EGGL_FLEE] = {SPR_EGGL, A, -1, A_BossDeath, 0, 0, S_EGGL_FLEE2}
states[S_EGGL_FLEE2] = {SPR_EGGL, A, -1, nil, 0, 0, S_EGGL_FLEE2}
--rocket states
states[S_BLUROCK_UP] = {SPR_BLUU, A, -1, nil, 0, 0, S_BLUROCK_UP}
states[S_BLUROCK_DOWN] = {SPR_BLUD, A, -1, nil, 0, 0, S_BLUROCK_DOWN}
--rocket aimy thingy
states[S_BLUEAIM] = {SPR_TARG, A, -1, nil, 0, 0, S_BLUEAIM}

mobjinfo[MT_EGGLAUNCHER] = {
	--$Title Egg Launcher
	--$Sprite EGGLA0
	--$Category PHLIGHT
	doomednum = 2305,
	spawnstate = S_EGGL_BASIC,
	painstate = S_EGGL_PAIN,
	deathstate = S_EGGL_DEATH,
	xdeathstate = S_EGGL_FLEE2,
	painsound = sfx_dmpain,
	deathsound = sfx_cybdth,
	dispoffset = -1,
	spawnhealth = 8,
	reactiontime = 0,
	painchance = 0,
	speed = 5,
	mass = 32,
	damage = 4,
	radius = 20*FRACUNIT,
	height = 64*FRACUNIT,
	flags = MF_SPECIAL|MF_SHOOTABLE|MF_BOSS|MF_NOGRAVITY
}

mobjinfo[MT_BLUEROCKET] = {
	--$Title Egg Launcher's Rocket
	--$Sprite BLUDA0
	--$Category PHLIGHT/Missiles (why would u need a missile spawner lol)
	doomednum = -1,
	spawnstate = S_BLUROCK_UP,
	deathstate = S_FBOMB_EXPL3,
	deathsound = sfx_lqboom,
	dispoffset = 1,
	spawnhealth = 99,
	reactiontime = 0,
	painchance = 0,
	speed = 5,
	mass = 32,
	radius = 32*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_MISSILE|MF_NOGRAVITY
}

mobjinfo[MT_PHROCKET] = {
	--$Title Egg Launcher Phinisher's Rocket
	--$Sprite BLUDA0
	--$Category PHLIGHT/Missiles (why would u need a missile spawner lol)
	doomednum = -1,
	spawnstate = S_BLUROCK_UP,
	deathstate = S_FBOMB_EXPL3,
	deathsound = sfx_lqboom,
	dispoffset = 1,
	spawnhealth = 99,
	reactiontime = 0,
	painchance = 0,
	speed = 5,
	mass = 32,
	radius = 32*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_MISSILE|MF_NOGRAVITY
}

mobjinfo[MT_BLUEAIM] = {
	--$Title Rocket's Aim
	--$Sprite TARGA0
	--$Category PHLIGHT/Missiles (why would u need a missile spawner lol)
	doomednum = -1,
	spawnstate = S_BLUEAIM,
	dispoffset = 0,
	spawnhealth = 99,
	reactiontime = 0,
	painchance = 0,
	speed = 5,
	radius = 32*FRACUNIT,
	height = 56*FRACUNIT,
	flags = MF_NOGRAVITY
}


addHook("MobjSpawn", function(boss)
	boss.deathtime = 0
	boss.delay = 90
	boss.phinisher = 0
	boss.phtimer = 0
	boss.phdelay = 3
end, MT_EGGLAUNCHER)

--EGG LAUNCHER THINKER
addHook("BossThinker", function(boss)
	boss.delay = $ - 1
	boss.phinisher = $ + 1
	if boss.health <= 1 then boss.phinisher = 999 end
	if boss.state == S_EGGL_DEATH then boss.deathtime = $ + 1 end --to repeat explosions
	if boss.deathtime == 60 then
		boss.state = S_EGGL_DEATH2
		boss.deathtime = $+1
	end
	if boss.state == S_EGGL_FLEE2 then return end
	if boss.state == S_EGGL_PAIN then --boss floats upwards if hit
		boss.momz = 4*FU
		return
	end
	if boss.z <= boss.floorz + 48*FU then --cool as heck floating
		if boss.momz > 2*FU
			boss.momz = 2*FU
		else
			boss.momz = $ + FU/10
		end
	else
		if boss.momz < -2*FU
			boss.momz = -2*FU
		else
			boss.momz = $ - FU/20
		end
	end
	--boss attacks
	if boss.delay <= 0 and boss.phinisher > 100+boss.health*28 and boss.health <= 4 then --pinch phase attack
		if boss.phtimer == 0 then S_StartSound(boss, sfx_rktatk) end
		boss.phtimer = $ + 1
		if boss.phtimer > 98 then --stop phinisher
			boss.phtimer = 0
			boss.phdelay = 3
			boss.delay = 94
			boss.phinisher = 0
		elseif boss.phtimer > 48
			boss.phdelay = $ - 1
			if boss.phdelay <= 0
				boss.phdelay = 3
				P_SpawnMobjFromMobj(boss, 0, 0, 0, MT_PHROCKET).target = boss
			end
		end
	elseif boss.delay <= 0 --basic attack
		S_StartSound(boss, sfx_launch)
		P_SpawnMobjFromMobj(boss, 0, 0, 0, MT_BLUEROCKET).target = boss
		boss.delay = 40 + boss.health*8
	end
end, MT_EGGLAUNCHER)

addHook("MobjSpawn", function(rocket)
	rocket.flytime = 70
	rocket.fixedtarget = false
	rocket.aimx = 0
	rocket.aimy = 0
end, MT_BLUEROCKET)

--NORMAL MISSILES THINKER
addHook("MobjThinker", function(rocket)
	if rocket.target == nil then P_RemoveMobj(rocket) return end
	if rocket.target.valid == false then P_RemoveMobj(rocket) return end
	if rocket.target.target == nil then P_ExplodeMissile(rocket) return end
	if rocket.flytime > 0 then
		rocket.z = $ + 6*FU
		rocket.flytime = $ - 1
	else
		if rocket.fixedtarget == false --lock on player
			for i = 0, 6 do
				--if miles "fraud" prower hugs walls this will punish him
				if i == 6 then P_SetOrigin(rocket, rocket.target.target.x, rocket.target.target.y, rocket.z) break end
				--if tails doesnt hugs walls then do this
				rocket.aimx = rocket.target.target.x + P_RandomRange(-160+i*24, 160-i*24)*FU
				rocket.aimy = rocket.target.target.y + P_RandomRange(-160+i*24, 160-i*24)*FU
				P_SetOrigin(rocket, rocket.aimx, rocket.aimy, rocket.z)
				--SET THE SECTOR'S TAG WHERE YOU WANT ROCKETS TO FALL TO [65]!!
				if rocket.subsector.sector.tag == 65 then break end
			end
			P_SpawnMobj(rocket.x, rocket.y, rocket.floorz, MT_BLUEAIM).target = rocket
			rocket.state = S_BLUROCK_DOWN
			rocket.fixedtarget = true
		end
		rocket.flags = $ & ~MF_NOGRAVITY
	end
	if rocket.state == S_FBOMB_EXPL3
		P_RadiusAttack(rocket, rocket.target, 160*FU)
	end
end, MT_BLUEROCKET)

--PINCH PHASE ATTACK ROCKETS
addHook("MobjSpawn", function(rocket)
	rocket.flytime = 35
	rocket.fixedtarget = false
end, MT_PHROCKET)

addHook("MobjThinker", function(rocket)
	if rocket.target == nil then P_RemoveMobj(rocket) return end
	if rocket.target.valid == false then P_RemoveMobj(rocket) return end
	if rocket.target.target == nil then P_ExplodeMissile(rocket) return end
	if rocket.flytime > 0 then
		rocket.z = $ + 12*FU
		rocket.flytime = $ - 1
	else
		if rocket.fixedtarget == false
			P_SetOrigin(rocket, P_RandomRange(-480,480)*FU, P_RandomRange(-480,480)*FU, rocket.z)
			P_SpawnMobj(rocket.x, rocket.y, rocket.floorz, MT_BLUEAIM).target = rocket
			rocket.state = S_BLUROCK_DOWN
			rocket.fixedtarget = true
		end
		rocket.momz = $ - 1*FU
	end
	if rocket.state == S_FBOMB_EXPL3
		P_RadiusAttack(rocket, rocket.target, 120*FU)
	end
end, MT_PHROCKET)

--if attacker has rocket floating up sprite do not damage cuz i said so
addHook("ShouldDamage", function(pmo, rocket, boss, dmg, type)
	if rocket == nil then return end
	if rocket.state == S_BLUROCK_UP then return false end
end)

--blue aim thingy thinker
addHook("MobjThinker", function(aimer)
	if aimer.target == nil or aimer.target.valid == false
	or aimer.target.state == S_FBOMB_EXPL6 then P_RemoveMobj(aimer) return end
end, MT_BLUEAIM)